//My_OB

class My_OB
{
  //************3Dオブジェクト 基本図形************************
    
  void U_Bolt(float r,float R,float H)//Ｕボルト
  {
    int sides=16;//分割数
    int SnR=16;//面数
    
    float[][] X=new float[SnR+1][sides+1];
    float[][] Y=new float[SnR+1][sides+1];
    float[][] Z=new float[SnR+1][sides+1];
    
    int i,j;
    for(j=0;j<=SnR;j++)
    {
      float Aj=j*PI/SnR;
      for(i=0;i<=sides;i++)
      {
        float Ai=i*2*PI/sides;
        X[j][i]=(R+r*cos(Ai))*cos(Aj);
        Y[j][i]=r*sin(Ai);
        Z[j][i]=(R+r*cos(Ai))*sin(Aj);
      }
    }
    
    for(j=0;j<SnR;j++)
    {
      beginShape(QUAD_STRIP);
      for (i = 0; i <= sides; ++i)
      {
        vertex(X[j][i],Y[j][i],Z[j][i]);
        vertex(X[j+1][i],Y[j+1][i],Z[j+1][i]);
      }
      endShape(CLOSE);
    }
    pushMatrix();translate(R,0,-H/2);
    Z_Bar(r,H);popMatrix();//Zバー
    pushMatrix();translate(-R,0,-H/2);
    Z_Bar(r,H);popMatrix();//Zバー
  }
  
  void Z_Bar(float r,float L)//Zバー
  {
     int sides=16;//分割数
    int Sn=2;//面数
    float Pz[]={-L/2,L/2};//z座標
    float R[]={r,r};//回転物半径
    
    int i,j;
    float angleIncrement = TWO_PI/sides;
    for(j=0;j<Sn-1;j++)
    {
      float angle = 0;
      beginShape(QUAD_STRIP);
      for (i = 0; i < sides + 1; ++i)
      {
        vertex(R[j]*cos(angle), R[j]*sin(angle), Pz[j]);
        vertex(R[j+1]*cos(angle), R[j+1]*sin(angle), Pz[j+1]);
        angle += angleIncrement;
      }
      endShape(CLOSE);
    }
    pushMatrix();translate(0,0,-L/2);
    beginShape();
    Z_Circle(r);popMatrix();//円
    endShape(CLOSE);
    beginShape();
    pushMatrix();translate(0,0,L/2);
    Z_Circle(r);popMatrix();//円
    endShape(CLOSE);
  }
  
  void Z_6Bar(float B,float L)//Z_6角支柱
  {
    int sides=6;//分割数=6
    int Sn=2;//面数
    float Pz[]={-L/2,L/2};//z座標
    float r=B/(2*cos(30*PI/180));
    float R[]={r,r};//回転物半径
    int i,j;
    float angleIncrement = TWO_PI/sides;
    for(j=0;j< Sn-1;j++)
    {
      float angle = 0;
      beginShape(QUAD_STRIP);
      for (i = 0; i <  sides + 1; ++i)
      {
        vertex(R[j]*cos(angle), R[j]*sin(angle), Pz[j]);
        vertex(R[j+1]*cos(angle), R[j+1]*sin(angle), Pz[j+1]);
        angle += angleIncrement;
      }
      endShape(CLOSE);
    }
    pushMatrix();translate(0,0,-L/2);
    Z_hexagon(B);popMatrix();//6角形
    pushMatrix();translate(0,0,L/2);
    Z_hexagon(B);popMatrix();//6角形
  
  }
  
  
  void Z_Ring(float r,float R)//リング
  {
    int sides=16;//分割数
    int SnR=32;//面数
    
    float[][] X=new float[SnR+1][sides+1];
    float[][] Y=new float[SnR+1][sides+1];
    float[][] Z=new float[SnR+1][sides+1];
    
    int i,j;
    for(j=0;j<=SnR;j++)
    {
      float Aj=j*2*PI/SnR;
      for(i=0;i<=sides;i++)
      {
        float Ai=i*2*PI/sides;
        X[j][i]=(R+r*cos(Ai))*cos(Aj);
        Y[j][i]=(R+r*cos(Ai))*sin(Aj);
        Z[j][i]=r*sin(Ai);
      }
    }
    
    for(j=0;j<SnR;j++)
    {
      beginShape(QUAD_STRIP);
      for (i = 0; i <= sides; ++i)
      {
        vertex(X[j][i],Y[j][i],Z[j][i]);
        vertex(X[j+1][i],Y[j+1][i],Z[j+1][i]);
      }
      endShape(CLOSE);
    }
  }
  
  
  void Z_Pipe(float Ro,float Ri,float L)//パイプ
  {
    pushMatrix();
    Z_Cylinder(Ro,L);
    Z_Cylinder(Ri,L);
    translate(0,0,-L/2);
    Z_Ring_2D(Ro,Ri);
    translate(0,0,L);
    Z_Ring_2D(Ro,Ri);
    popMatrix();
  }
  
  void Z_SqPipe(float Wo,float Wi,float L)//角パイプ
  {
    float Ro=Wo/sqrt(2);
    float Ri=Wi/sqrt(2);
    
    pushMatrix();
    rotateZ(45*PI/180);
    Z_SqCylinder(Ro,L);
    Z_SqCylinder(Ri,L);
    translate(0,0,-L/2);
    Z_SqRing_2D(Ro,Ri);
    translate(0,0,L);
    Z_SqRing_2D(Ro,Ri);
    popMatrix();
  }
  
  void Z_Angle(float W,float T,float L)//Angle 山形鋼
  {
    int Pn=7;//ポイント数
    float x1=W/2;
    float x2=W/2-T;
    float X[]={-x2,-x1,-x1,x1,x1,-x2,-x2};
    float Y[]={-x1,-x1,x1,x1,x2,x2,-x1};
    
    pushMatrix();
    Z_Side(Pn,X,Y,L);//側面
    translate(0,0,-L/2);
    Z_Polyon(Pn,X,Y);//多角形
    translate(0,0,L);
    Z_Polyon(Pn,X,Y);//多角形
    popMatrix();
  }
  
  
  void Z_H_shape(float H,float B,float T1,float T2,float L)//H_shape H形鋼
  {
    int Pn=13;//ポイント数
    float x1=B/2;
    float x2=T1/2;
    float y1=H/2;
    float y2=H/2-T2;
    
    float X[]={-x1,x1,x1,x2,x2,x1,x1,-x1,-x1,-x2,-x2,-x1,-x1};
    float Y[]={-y1,-y1,-y2,-y2,y2,y2,y1,y1,y2,y2,-y2,-y2,-y1};
    
    pushMatrix();
    Z_Side(Pn,X,Y,L);//側面
    translate(0,0,-L/2);
    Z_Polyon(Pn,X,Y);//多角形
    translate(0,0,L);
    Z_Polyon(Pn,X,Y);//多角形
    popMatrix();
  }
  
  void Z_Channel(float H,float B,float T1,float T2,float L)//Channel みぞ形鋼
  {
    int Pn=9;//ポイント数
    float x1=B/2;
    float x2=B/2-T1;
    float y1=H/2;
    float y2=H/2-T2;
    
    float X[]={-x1,-x1,x1,x1,-x2,-x2,x1,x1,-x1};
    float Y[]={-y1,y1,y1,y2,y2,-y2,-y2,-y1,-y1};
    
    pushMatrix();
    Z_Side(Pn,X,Y,L);//側面
    translate(0,0,-L/2);
    Z_Polyon(Pn,X,Y);//多角形
    translate(0,0,L);
    Z_Polyon(Pn,X,Y);//多角形
    popMatrix();
  }
  
  void Z_Nut(float B,float T,float R)//六角ナット
  {
    int Pn=7;//ポイント数
    float[] X=new float[Pn];
    float[] Y=new float[Pn];
    int i;
    float r=B/(2*cos(30*PI/180));
    for(i=0;i<Pn;i++)
    {
      float angle = i*TWO_PI/(Pn-1);
      X[i]=r*cos(angle);Y[i]=r*sin(angle);
    }
    
    int Pn2=17;//ポイント数
    float[] X2=new float[Pn2];
    float[] Y2=new float[Pn2];
    for(i=0;i<Pn2;i++)
    {
      float angle = i*TWO_PI/(Pn2-1);
      X2[i]=R*cos(angle);Y2[i]=R*sin(angle);
    }
  
    pushMatrix();
    Z_Side(Pn,X,Y,T);//側面
    Z_Side(Pn2,X2,Y2,T);//側面
    translate(0,0,-T/2);
    beginShape();
    Z_Polyon_P(Pn,X,Y);//多角形
    beginContour();
    Z_Polyon_M(Pn2,X2,Y2);//多角形
    endContour();
    endShape(CLOSE);
    translate(0,0,T);
    beginShape();
    Z_Polyon_P(Pn,X,Y);//多角形
    beginContour();
    Z_Polyon_M(Pn2,X2,Y2);//多角形
    endContour();
    endShape(CLOSE);
    popMatrix();
  }
  
  void Bolt_A(float r,float R,float H,float L)//六角穴付きボルト
  {
    pushMatrix();translate(0,0,H/2);
    Z_Bar(R,H);popMatrix();//Zバー
    pushMatrix();translate(0,0,-L/2);
    Z_Bar(r,L);popMatrix();//Zバー
  }
  
  void Bolt_B(float r,float B,float H,float L)//六角ボルト
  {
    pushMatrix();translate(0,0,H/2);
    Z_6Bar(B,H);popMatrix();//Z_6角支柱
    pushMatrix();translate(0,0,-L/2);
    Z_Bar(r,L);popMatrix();//Zバー
  }
  
  void Bolt_C(float r,float R,float L)//六角穴付き皿ボルト
  {
    
    int Sn=3;//面数
    int Pn=17;//ポイント数
  
    float[][] X=new float[Sn][Pn];
    float[][] Y=new float[Sn][Pn];
    float[] Z=new float[Sn];
    int i;
    
    Z[0]=0;
    Z[1]=-(R-r);
    Z[2]=-L;
    for(i=0;i<Pn;i++)
    {
      float angle = i*TWO_PI/(Pn-1);
      X[0][i]=R*cos(angle);Y[0][i]=R*sin(angle);
      X[1][i]=r*cos(angle);Y[1][i]=r*sin(angle);
      X[2][i]=r*cos(angle);Y[2][i]=r*sin(angle);
    }
    pushMatrix();
    Z_Side_M(Sn,Pn,X,Y,Z);//多段側面
    beginShape();
    Z_Polyon_P(Pn,X[0],Y[0]);//多角形反時計回り
    endShape(CLOSE);
    translate(0,0,Z[2]);
    beginShape();
    Z_Polyon_P(Pn,X[2],Y[2]);//多角形反時計回り
    endShape(CLOSE);
    popMatrix();
  }
  
  void Bolt_D(float r,float R,float H,float L)//台形頭ボルト（アイボルト合成用)
  {
    int Sn=4;//面数
    int Pn=17;//ポイント数
    float[][] X=new float[Sn][Pn];
    float[][] Y=new float[Sn][Pn];
    float[] Z=new float[Sn];
    int i;
    float R0=R-H*tan(PI*(90-82)/180);
    
    Z[0]=H;
    Z[1]=0;
    Z[2]=0;
    Z[3]=-L;
    for(i=0;i<Pn;i++)
    {
      float angle = i*TWO_PI/(Pn-1);
      X[0][i]=R0*cos(angle);Y[0][i]=R0*sin(angle);
      X[1][i]=R*cos(angle);Y[1][i]=R*sin(angle);
      X[2][i]=r*cos(angle);Y[2][i]=r*sin(angle);
      X[3][i]=r*cos(angle);Y[3][i]=r*sin(angle);
    }
    pushMatrix();
    Z_Side_M(Sn,Pn,X,Y,Z);//多段側面
    translate(0,0,Z[0]);
    beginShape();
    Z_Polyon_P(Pn,X[0],Y[0]);//多角形反時計回り
    endShape(CLOSE);
    popMatrix();
    pushMatrix();
    translate(0,0,Z[3]);
    beginShape();
    Z_Polyon_P(Pn,X[3],Y[3]);//多角形反時計回り
    endShape(CLOSE);
    popMatrix();
  }
  
  void Bolt_E(float r,float R,float H,float L,float M,float D)//アイボルト
  {
    Bolt_D(M/2,D/2,H-(R-r),L);//台形頭ボルト（アイボルト合成用)
    pushMatrix();
    rotateY(90*PI/180);
    translate(-H,0,0);
    Z_Ring(r,R);//リング
    popMatrix();
  }
  
  
  //ケーブルグランド本体
  void Catalog_01_1(float M,float D1,float L1,float L2,float L3,float L4,float L5)
  {
    int Sn=9;//面数
    int Pn=17;//ポイント数
    float[][] X=new float[Sn][Pn];
    float[][] Y=new float[Sn][Pn];
    float[] Z=new float[Sn];
    int i;
    
    Z[0]=L1;
    Z[1]=0;
    Z[2]=0;
    Z[3]=-L2;
    Z[4]=-L2;
    Z[5]=-L2-L4;
    Z[6]=-L2-L4;
    Z[7]=-L2-L3+L5;
    Z[8]=-L2-L3;
    for(i=0;i<Pn;i++)
    {
      float angle = i*TWO_PI/(Pn-1);
      X[0][i]=(M/2)*cos(angle);Y[0][i]=(M/2)*sin(angle);
      X[1][i]=(M/2)*cos(angle);Y[1][i]=(M/2)*sin(angle);
      X[2][i]=(D1/2)*cos(angle);Y[2][i]=(D1/2)*sin(angle);
      X[3][i]=(D1/2)*cos(angle);Y[3][i]=(D1/2)*sin(angle);
      X[4][i]=(M/2)*cos(angle);Y[4][i]=(M/2)*sin(angle);
      X[5][i]=(M/2)*cos(angle);Y[5][i]=(M/2)*sin(angle);
      X[6][i]=(D1/2)*cos(angle);Y[6][i]=(D1/2)*sin(angle);
      X[7][i]=(D1/2)*cos(angle);Y[7][i]=(D1/2)*sin(angle);
      X[8][i]=(D1/2-L5)*cos(angle);Y[8][i]=(D1/2-L5)*sin(angle);
    }
    pushMatrix();
    Z_Side_M(Sn,Pn,X,Y,Z);//多段側面
    translate(0,0,Z[0]);
    beginShape();
    Z_Polyon_P(Pn,X[0],Y[0]);//多角形反時計回り
    endShape(CLOSE);
    popMatrix();
    pushMatrix();
    translate(0,0,Z[8]);
    beginShape();
    Z_Polyon_P(Pn,X[8],Y[8]);//多角形反時計回り
    endShape(CLOSE);
    popMatrix();
  }
  
  //STD_01）パイプクランプ
  void STD_01(float L1,float L2,float L3,float L4,float L5,float R,float r)
  {
    int An=8;
    int Pn=An+6;//ポイント数
    float[] X=new float[Pn];
    float[] Z=new float[Pn];
    int i;
    float dA=2*acos(L4/R)/An;;
    //float AA=dA*4;
    for(i=0;i<= An;i++)
    {
      float angle = (i-An/2)*dA;
      X[i]=R*sin(angle);Z[i]=R*cos(angle);
    }
    X[An+1]=L1/2;Z[An+1]=L4;
    X[An+2]=L1/2;Z[An+2]=L4+L3;
    X[An+3]=-L1/2;Z[An+3]=L4+L3;
    X[An+4]=-L1/2;Z[An+4]=L4;
    X[An+5]=X[0];Z[An+5]=Z[0];
    Y_Side(An+1,X,Z,L2);//側面
    
    
    int Pn2=5;//ポイント数
    float[] X2=new float[Pn2];
    float[] Y2=new float[Pn2];
    float[] Z2=new float[Pn2];
    
    int Pn3=17;//ポイント数
    float[] X3=new float[Pn3];
    float[] Y3=new float[Pn3];
    for(i=0;i<Pn3;i++)
    {
      float angle = i*TWO_PI/(Pn3-1);
      X3[i]=r*cos(angle)+L5/2;Y3[i]=r*sin(angle);
    }
    
    int Pn4=17;//ポイント数
    float[] X4=new float[Pn4];
    float[] Y4=new float[Pn4];
    for(i=0;i<Pn4;i++)
    {
      float angle = i*TWO_PI/(Pn4-1);
      X4[i]=r*cos(angle)-L5/2;Y4[i]=r*sin(angle);
    }
    
    
    X2[0]=X[An];Y2[0]=-L2/2;
    X2[1]=L1/2;Y2[1]=-L2/2;
    X2[2]=L1/2;Y2[2]=L2/2;
    X2[3]=X[An];Y2[3]=L2/2;
    X2[4]=X[An];Y2[4]=-L2/2;
    beginShape();
    Z_Polyon_PZ(Pn2,X2,Y2,L4);//多角形
    beginContour();
    Z_Polyon_MZ(Pn3-1,X3,Y3,L4);//多角形
    endContour();
    endShape(CLOSE);
    
    X2[0]=-X[An];Y2[0]=-L2/2;
    X2[1]=-X[An];Y2[1]=L2/2;
    X2[2]=-L1/2;Y2[2]=L2/2;
    X2[3]=-L1/2;Y2[3]=-L2/2;
    X2[4]=-X[An];Y2[4]=-L2/2;
    beginShape();
    Z_Polyon_PZ(Pn2,X2,Y2,L4);//多角形
    beginContour();
    Z_Polyon_MZ(Pn4-1,X4,Y4,L4);//多角形
    endContour();
    endShape(CLOSE);
    
    X2[0]=L1/2;Y2[0]=L2/2;
    X2[1]=-L1/2;Y2[1]=L2/2;
    X2[2]=-L1/2;Y2[2]=-L2/2;
    X2[3]=L1/2;Y2[3]=-L2/2;
    X2[4]=L1/2;Y2[4]=L2/2;
  
    beginShape();
    Z_Polyon_PZ(Pn2,X2,Y2,L3+L4);//多角形
    beginContour();
    Z_Polyon_MZ(Pn3-1,X3,Y3,L3+L4);//多角形
    endContour();
    beginContour();
    Z_Polyon_MZ(Pn4-1,X4,Y4,L3+L4);//多角形
    endContour();
    endShape(CLOSE);
    
    pushMatrix();
    translate(0,0,L4+L3/2);
    Z_Side(Pn3,X3,Y3,L3);//側面
    Z_Side(Pn4,X4,Y4,L3);//側面
    popMatrix();
  
    Y2[0]=-L2/2;Z2[0]=L4;
    Y2[1]=L2/2;Z2[1]=L4;
    Y2[2]=L2/2;Z2[2]=L4+L3;
    Y2[3]=-L2/2;Z2[3]=L4+L3;
    Y2[4]=-L2/2;Z2[4]=L4;
    beginShape();
    X_Polyon_PX(Pn2,L1/2,Y2,Z2);//多角形
    endShape(CLOSE);
    beginShape();
    X_Polyon_PX(Pn2,-L1/2,Y2,Z2);//多角形
    endShape(CLOSE);
    
    beginShape();
    Y_Polyon_PY(Pn,X,-L2/2,Z);//多角形
    endShape(CLOSE);
    beginShape();
    Y_Polyon_PY(Pn,X,L2/2,Z);//多角形
    endShape(CLOSE);
  }
  
  
  
  
  void STD_02(float W,float T,float L,float R)//STD_02）ベース
  {
    int Pn=17;//ポイント数
    int Pn2=5;//ポイント数
    float[] X=new float[Pn];
    float[] Z=new float[Pn];
    float[] X1=new float[Pn];
    float[] Z1=new float[Pn];
    float[] X2=new float[Pn2];
    float[] Z2=new float[Pn2];
    int i;
    
    for(i=0;i<Pn;i++)
    {
      float angle = i*TWO_PI/(Pn-1);
      X1[i]=R*cos(angle);Z1[i]=R*sin(angle);
    }
    
    X2[0]=W/2;Z2[0]=W/2;
    X2[1]=-W/2;Z2[1]=W/2;
    X2[2]=-W/2;Z2[2]=-W/2;
    X2[3]=W/2;Z2[3]=-W/2;
    X2[4]=W/2;Z2[4]=W/2;
    beginShape();
    Y_Polyon_PY(Pn2,X2,T/2,Z2);//多角形
    for(i=0;i<Pn;i++){X[i]=X1[i]+L/2;Z[i]=Z1[i]+L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,T/2,Z);//多角形
    endContour();
    for(i=0;i<Pn;i++){X[i]=X1[i]-L/2;Z[i]=Z1[i]+L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,T/2,Z);//多角形
    endContour();
    for(i=0;i<Pn;i++){X[i]=X1[i]-L/2;Z[i]=Z1[i]-L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,T/2,Z);//多角形
    endContour();
    for(i=0;i<Pn;i++){X[i]=X1[i]+L/2;Z[i]=Z1[i]-L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,T/2,Z);//多角形
    endContour();
    endShape(CLOSE);
    
    beginShape();
    Y_Polyon_PY(Pn2,X2,-T/2,Z2);//多角形
    for(i=0;i<Pn;i++){X[i]=X1[i]+L/2;Z[i]=Z1[i]+L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,-T/2,Z);//多角形
    endContour();
    for(i=0;i<Pn;i++){X[i]=X1[i]-L/2;Z[i]=Z1[i]+L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,-T/2,Z);//多角形
    endContour();
    for(i=0;i<Pn;i++){X[i]=X1[i]-L/2;Z[i]=Z1[i]-L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,-T/2,Z);//多角形
    endContour();
    for(i=0;i<Pn;i++){X[i]=X1[i]+L/2;Z[i]=Z1[i]-L/2;}
    beginContour();
    Y_Polyon_MY(Pn-1,X,-T/2,Z);//多角形
    endContour();
    endShape(CLOSE);
    
    pushMatrix();
    translate(L/2,0,L/2);
    Y_Side(Pn,X1,Z1,T);//側面
    translate(-L,0,0);
    Y_Side(Pn,X1,Z1,T);//側面
    translate(0,0,-L);
    Y_Side(Pn,X1,Z1,T);//側面
    translate(L,0,0);
    Y_Side(Pn,X1,Z1,T);//側面
    popMatrix();
    
    Y_Side(Pn2,X2,Z2,T);//側面  
  }
  
  void Z_Polyon_Plate(int Pn,float X[],float Y[],float L)//多角形板
  {
    pushMatrix();
    //void Z_Side(int Pn,float X[],float Y[],float L)//側面
    Z_Side(Pn,X,Y,L);
    translate(0,0,-L/2);
    //void Z_Polyon(int Pn,float X[],float Y[])//多角形
    Z_Polyon(Pn,X,Y);
    translate(0,0,L);
    Z_Polyon(Pn,X,Y);
    popMatrix();
  }
  
  //STD_03）パイプクランプ-穴4個（穴間隔L6＝120）
  void STD_03(float L1,float L2,float L3,float L4,float L5,float L6,float R,float r)
  {
    int An=8;
    int Pn=An+6;//ポイント数
    float[] X=new float[Pn];
    float[] Z=new float[Pn];
    int i;
    float dA=2*acos(L4/R)/An;;
    //float AA=dA*4;
    for(i=0;i<= An;i++)
    {
      float angle = (i-An/2)*dA;
      X[i]=R*sin(angle);Z[i]=R*cos(angle);
    }
    X[An+1]=L1/2;Z[An+1]=L4;
    X[An+2]=L1/2;Z[An+2]=L4+L3;
    X[An+3]=-L1/2;Z[An+3]=L4+L3;
    X[An+4]=-L1/2;Z[An+4]=L4;
    X[An+5]=X[0];Z[An+5]=Z[0];
    Y_Side(An+1,X,Z,L2);//側面
    
    
    int Pn2=5;//ポイント数
    float[] X2=new float[Pn2];
    float[] Y2=new float[Pn2];
    float[] Z2=new float[Pn2];
    
    int Pn3=17;//ポイント数
    float[] X3=new float[Pn3];
    float[] Y3=new float[Pn3];
    float[] X4=new float[Pn3];
    float[] Y4=new float[Pn3];
    float[] X5=new float[Pn3];
    float[] Y5=new float[Pn3];
    float[] X6=new float[Pn3];
    float[] Y6=new float[Pn3];
    
    
    for(i=0;i<Pn3;i++)
    {
      float angle = i*TWO_PI/(Pn3-1);
      X3[i]=r*cos(angle)+L5/2;Y3[i]=r*sin(angle)+L6/2;
      X4[i]=r*cos(angle)-L5/2;Y4[i]=r*sin(angle)+L6/2;
      X5[i]=r*cos(angle)+L5/2;Y5[i]=r*sin(angle)-L6/2;
      X6[i]=r*cos(angle)-L5/2;Y6[i]=r*sin(angle)-L6/2;
    }
    
    
    X2[0]=X[An];Y2[0]=-L2/2;
    X2[1]=L1/2;Y2[1]=-L2/2;
    X2[2]=L1/2;Y2[2]=L2/2;
    X2[3]=X[An];Y2[3]=L2/2;
    X2[4]=X[An];Y2[4]=-L2/2;
    beginShape();
    Z_Polyon_PZ(Pn2,X2,Y2,L4);//多角形
    beginContour();
    Z_Polyon_MZ(Pn3-1,X3,Y3,L4);//多角形
    endContour();
    beginContour();
    Z_Polyon_MZ(Pn3-1,X5,Y5,L4);//多角形
    endContour();
    endShape(CLOSE);
    
    X2[0]=-X[An];Y2[0]=-L2/2;
    X2[1]=-X[An];Y2[1]=L2/2;
    X2[2]=-L1/2;Y2[2]=L2/2;
    X2[3]=-L1/2;Y2[3]=-L2/2;
    X2[4]=-X[An];Y2[4]=-L2/2;
    beginShape();
    Z_Polyon_PZ(Pn2,X2,Y2,L4);//多角形
    beginContour();
    Z_Polyon_MZ(Pn3-1,X4,Y4,L4);//多角形
    endContour();
    beginContour();
    Z_Polyon_MZ(Pn3-1,X6,Y6,L4);//多角形
    endContour();
    endShape(CLOSE);
    
    X2[0]=L1/2;Y2[0]=L2/2;
    X2[1]=-L1/2;Y2[1]=L2/2;
    X2[2]=-L1/2;Y2[2]=-L2/2;
    X2[3]=L1/2;Y2[3]=-L2/2;
    X2[4]=L1/2;Y2[4]=L2/2;
  
    beginShape();
    Z_Polyon_PZ(Pn2,X2,Y2,L3+L4);//多角形
    beginContour();
    Z_Polyon_MZ(Pn3-1,X3,Y3,L3+L4);//多角形
    endContour();
    beginContour();
    Z_Polyon_MZ(Pn3-1,X4,Y4,L3+L4);//多角形
    endContour();
    beginContour();
    Z_Polyon_MZ(Pn3-1,X5,Y5,L3+L4);//多角形
    endContour();
    beginContour();
    Z_Polyon_MZ(Pn3-1,X6,Y6,L3+L4);//多角形
    endContour();
    endShape(CLOSE);
    
    pushMatrix();
    translate(0,0,L4+L3/2);
    Z_Side(Pn3,X3,Y3,L3);//側面
    Z_Side(Pn3,X4,Y4,L3);//側面
    Z_Side(Pn3,X5,Y5,L3);//側面
    Z_Side(Pn3,X6,Y6,L3);//側面
    popMatrix();
  
    Y2[0]=-L2/2;Z2[0]=L4;
    Y2[1]=L2/2;Z2[1]=L4;
    Y2[2]=L2/2;Z2[2]=L4+L3;
    Y2[3]=-L2/2;Z2[3]=L4+L3;
    Y2[4]=-L2/2;Z2[4]=L4;
    beginShape();
    X_Polyon_PX(Pn2,L1/2,Y2,Z2);//多角形
    endShape(CLOSE);
    beginShape();
    X_Polyon_PX(Pn2,-L1/2,Y2,Z2);//多角形
    endShape(CLOSE);
    
    beginShape();
    Y_Polyon_PY(Pn,X,-L2/2,Z);//多角形
    endShape(CLOSE);
    beginShape();
    Y_Polyon_PY(Pn,X,L2/2,Z);//多角形
    endShape(CLOSE);
  }
  
  
  void Z_Parasol(int Sn,float R,float A)//パラソル面
  {
    int Pn=17;//ポイント数
    float[][] X=new float[Sn+1][Pn];
    float[][] Y=new float[Sn+1][Pn];
    float[] Z=new float[Sn+1];
    int i,j;
    for(j=0;j<=Sn;j++)
    {
      float Aj=j*A*PI/(180*(Sn-1));
      Z[j]=R*cos(Aj);
      float Ry=R*sin(Aj);
      for(i=0;i<Pn;i++)
      {
        float Ai = i*TWO_PI/(Pn-1);
        X[j][i]=Ry*cos(Ai);
        Y[j][i]=Ry*sin(Ai);
      }
    }
    //void Z_Side_M(int Sn,int Pn,float X[][],float Y[][],float Z[])//多段側面
    Z_Side_M(Sn,Pn,X,Y,Z); 
  }
  
  void Z_Parasol_Z(int Sn,float R,float A,float Z)//Z指定パラソル面
  {
    pushMatrix();
    translate(0,0,Z);
    Z_Parasol(Sn,R,A);
    popMatrix();
  }
  
  void Z_Bar_Z(float r,float L,float Z)//Z指定丸棒
  {
    pushMatrix();
    translate(0,0,Z);
    Z_Bar(r,L);
    popMatrix();
  }

  

  
  
  
  
  
  
  
    //************2Dオブジェクト************************
    void Z_Circle(float r)//円
  {
    int sides=16;//分割数
    int i;
    float angleIncrement = TWO_PI/sides;
    float angle = 0;
    beginShape();
    for (i = 0; i < sides + 1; ++i)
    {
      
      vertex(r*cos(angle), r*sin(angle),0);
      vertex(r*cos(angle), r*sin(angle),0);
      angle += angleIncrement;
    }
    endShape(CLOSE);
  }
  
  
  void Z_hexagon(float B)//6角形
  {
    int sides=6;//分割数=6
    float r=B/(2*cos(30*PI/180));
    int i;
    float angleIncrement = TWO_PI/sides;
    float angle = 0;
    beginShape();
    for (i = 0; i <  sides + 1; ++i)
    {
      vertex(r*cos(angle), r*sin(angle),0);
      angle += angleIncrement;
    }
    endShape(CLOSE);
  }
  
  void Z_Cylinder(float r,float L)//円筒
  {
    int sides=16;//分割数
    int i;
    beginShape(QUAD_STRIP);
    for (i = 0; i < sides + 1; ++i)
    {
      float angle = i*TWO_PI/sides;
      vertex(r*cos(angle), r*sin(angle), -L/2);
      vertex(r*cos(angle), r*sin(angle), L/2);
    }
    endShape(CLOSE);
  }
  
  void Z_Ring_2D(float Ro,float Ri)
  {
    int sides=16;//分割数
    int i;
    beginShape();
    for (i = 0; i < sides + 1; ++i)
    {
      float angle = i*TWO_PI/sides;
      vertex(Ro*cos(angle), Ro*sin(angle),0);
    }
    beginContour();
    for (i = 0; i < sides + 1; ++i)
    {
      float angle = -i*TWO_PI/sides;
      vertex(Ri*cos(angle), Ri*sin(angle),0);
    }
    endContour();
  
    endShape(CLOSE);
  }
  
  void Z_SqCylinder(float r,float L)//角筒
  {
    int sides=4;//分割数
    int i;
    beginShape(QUAD_STRIP);
    for (i = 0; i < sides + 1; ++i)
    {
      float angle = i*TWO_PI/sides;
      vertex(r*cos(angle), r*sin(angle), -L/2);
      vertex(r*cos(angle), r*sin(angle), L/2);
    }
    endShape(CLOSE);
  }
  
  void Z_SqRing_2D(float Ro,float Ri)
  {
    int sides=4;//分割数
    int i;
    beginShape();
    for (i = 0; i < sides + 1; ++i)
    {
      float angle = i*TWO_PI/sides;
      vertex(Ro*cos(angle), Ro*sin(angle),0);
    }
    beginContour();
    for (i = 0; i < sides + 1; ++i)
    {
      float angle = -i*TWO_PI/sides;
      vertex(Ri*cos(angle), Ri*sin(angle),0);
    }
    endContour();
  
    endShape(CLOSE);
  }
  
  void Z_Side(int Pn,float X[],float Y[],float L)//側面
  {
    int i;
    beginShape(QUAD_STRIP);
    for (i = 0; i < Pn; ++i)
    {
      vertex(X[i],Y[i], -L/2);
      vertex(X[i],Y[i], L/2);
    }
    endShape(CLOSE);
  }
  
  void Y_Side(int Pn,float X[],float Z[],float L)//Y軸　側面
  {
    int i;
    beginShape(QUAD_STRIP);
    for (i = 0; i < Pn; i++)
    {
      vertex(X[i],-L/2,Z[i]);
      vertex(X[i],L/2,Z[i]);
    }
    endShape(CLOSE);
  }
  
  void Z_Polyon(int Pn,float X[],float Y[])//多角形
  {
    int i;
    beginShape();
    for (i = 0; i < Pn; ++i)
    {
      vertex(X[i],Y[i]);
    }
    endShape(CLOSE);
  }
  
  
  
  void Z_Polyon_P(int Pn,float X[],float Y[])//多角形反時計回り
  {
    int i;
    for (i = 0; i < Pn; i++)
    {
      vertex(X[i],Y[i]);
    }
  }
  
  void Z_Polyon_M(int Pn,float X[],float Y[])//多角形時計回り
  {
    int i;
    for (i = Pn-1; i >= 0; i--)
    {
      vertex(X[i],Y[i]);
    }
  }
  
  void Z_Side_M(int Sn,int Pn,float X[][],float Y[][],float Z[])//多段側面
  {
    int i,j;
    
    for(j=0;j<Sn-1;j++)
    {
      beginShape(QUAD_STRIP);
      for (i = 0; i < Pn; i++)
      {
        vertex(X[j][i],Y[j][i], Z[j]);
        vertex(X[j+1][i],Y[j+1][i], Z[j+1]);
      }
      endShape(CLOSE);
    }
  }
  
  
  void Z_Polyon_PZ(int Pn,float X[],float Y[],float Z)//多角形反時計回り
  {
    int i;
    for (i = 0; i < Pn; i++)
    {
      vertex(X[i],Y[i],Z);
    }
  }
  
  void Y_Polyon_P(int Pn,float X[],float Z[])//Y軸　多角形反時計回り
  {
    int i;
    for (i = 0; i < Pn; i++)
    {
      vertex(X[i],0,Z[i]);
    }
  }
  
  void Y_Polyon_PY(int Pn,float X[],float Y,float Z[])//Y軸　多角形反時計回り
  {
    int i;
    for (i = 0; i < Pn; i++)
    {
      vertex(X[i],Y,Z[i]);
    }
  }
  
  void X_Polyon_PX(int Pn,float X,float Y[],float Z[])//X軸　多角形反時計回り
  {
    int i;
    for (i = 0; i < Pn; i++)
    {
      vertex(X,Y[i],Z[i]);
    }
  }
  
  
  
  void Z_Polyon_MZ(int Pn,float X[],float Y[],float Z)//多角形時計回り
  {
    int i;
    for (i = Pn-1; i >= 0; i--)
    {
      vertex(X[i],Y[i],Z);
    }
  }
  
  void Y_Polyon_MY(int Pn,float X[],float Y,float Z[])//多角形時計回り
  {
    int i;
    for (i = Pn-1; i >= 0; i--)
    {
      vertex(X[i],Y,Z[i]);
    }
  }
  
  void X_Hole_XYZ(float r,float X,float Y,float Z)//擬似ホール
  {
    fill(55, 55, 55);
    int sides=16;//分割数
    int i;
    float angleIncrement = TWO_PI/sides;
    float angle = 0;
    beginShape();
    for (i = 0; i < sides + 1; ++i)
    {
      
      vertex(X,r*cos(angle)+Y, r*sin(angle)+Z);
      //vertex(X,r*cos(angle), r*sin(angle));
      angle += angleIncrement;
    }
    endShape(CLOSE);
    fill(255, 255, 255);
  }
  
  void Y_Hole_XYZ(float r,float X,float Y,float Z)//擬似ホール
  {
    fill(55, 55, 55);
    int sides=16;//分割数
    int i;
    float angleIncrement = TWO_PI/sides;
    float angle = 0;
    beginShape();
    for (i = 0; i < sides + 1; ++i)
    {
      vertex(r*cos(angle)+X,Y,Z+r*sin(angle));
      angle += angleIncrement;
    }
    endShape(CLOSE);
    fill(255, 255, 255);
  }
  
 }